function validate(tri,V){
	var A = V[tri[0]].clone().sub(V[tri[1]])
	var B = V[tri[2]].clone().sub(V[tri[1]])
	var C = new THREE.Vector3()
	
	var dot00 = A.dot(A)
	var dot01 = A.dot(B)
	var dot11 = B.dot(B)
	
	
	var ox = A.x
	A.x = -A.z
	A.z = ox
	if(A.dot(B)>=0){return false} //triangle has invalid wrapping
	A.z = -A.x
	A.x = ox
	for(var ii=0;ii<V.length;ii++){
		if(V[ii].distanceTo(V[tri[0]])==0){continue}
		if(V[ii].distanceTo(V[tri[1]])==0){continue}
		if(V[ii].distanceTo(V[tri[2]])==0){continue}
		C = V[ii].clone().sub(V[tri[1]])
		
		var dot02 = A.dot(C)
		var dot12 = B.dot(C)

		// Compute barycentric coordinates
		var invDenom = 1 / (dot00 * dot11 - dot01 * dot01)
		var u = (dot11 * dot02 - dot01 * dot12) * invDenom
		var v = (dot00 * dot12 - dot01 * dot02) * invDenom
		// Check if point is in triangle
		if(((u >= 0) && (v >= 0) && (u + v < 1))){
			return false
		}
	}
	return true
}

function decompose_Shape(Target){
	var faces = []
	var nT = []
	var Ti = []
	if(Target.length>4){
		var debug=true
		var height = 0
	}
	
	for(var ii=0;ii<Target.length;ii++){
		Ti.push(ii)
	}
	
	nT.push(Ti.splice(0,1)[0])
	nT.push(Ti.splice(0,1)[0])
	nT.push(Ti.splice(0,1)[0])
	
	var safety = 100
	while(true){
		safety--
		if(safety<0){break}
		
		if(validate(nT,Target)){
			//make triangle
			console.log("TRIANGULAR")
			faces.push(new THREE.Face3(nT[0],nT[1],nT[2]))
			
			
			nT[1] = nT[2]
			if(debug){
				displayPath([Target[nT[0]],Target[nT[1]]],300+height*4)
				height++
			}
		}else{
			Ti.push(nT[0])
			nT[0] = nT[1]
			nT[1] = nT[2]
		}
		if(Ti.length<1){
			break
		}
		
		nT[2] = Ti.splice(0,1)[0]
		if(nT.indexOf(undefined)>=0){
			break
		}
	}
	if(safety<0){console.log("Could not decompose surface")}
	return faces
}